package DB;

use Carp;
use strict;

## Nothing done, just a prototype for children class

sub TIEHASH {
  my $class = shift;
  my $id = shift || croak "Bad key id: $!\n";
  my $node = {'id' => $id};
  
  return bless $node, $class;
}

sub FETCH {
  my $self = shift;
  my $id = shift;
  
}

sub EXISTS {
  my $self = shift;
  my $id = shift;
  
}

sub FIRSTKEY {
  my $self = shift;

}

sub NEXTKEY {
  my $self = shift;

}

sub DESTROY {
  my $self = shift;
  
}

## STORE/DELETE/CLEAR not needed since the access to the db is read-only

## Other specific methods allowed

sub clear_cache {
  my $self = shift;
  
}

## Get the index of all quotes : code => name
## The argument is a reference to a hash
sub get_index {
  my $r_hash = shift;

}

1;

__END__

=head1 DB.pm

The primary intent of this module is to help people writing DB::*
modules. It defines all the sub that are B<needed>. 

The TIEHASH, FETCH EXISTS, FIRSTKEY, NEXTKEY
and DESTROY subs are for enabling a tie. Look at man perltie.

The get_index sub is NOT an object sub, because we cannot open a
object before knowing which key id are available. The first argument
is a reference to a hash which has to be filled with all 
'id' => 'name' available. Next argument are the same than TIEHASH,
they will come from db_access_options.

=cut
