package Indicators::MM;

use strict;
use vars qw($code);

## Nouvelle mthode, une chaine qui va etre evalue  l'xcution une
## seule fois. Elle peut utiliser le hash de donnes via %data et
## doit chercher les dates  partir du tableau @date qui contient
## une conversion 'numero' => 'date'. La fonction bnficie du
## numro de jour dans $ind. Elle ne doit pas utiliser des jours en-dehors
## de l'intervalle prvu (cf informations fournies dans l'un register)

$code = q# 

my ($c, $sum) = (1, 0);
my $nbre = shift || 30;
for($c = 1 ; $c <= $nbre ; $c++) {
 $sum += $data{$date[$ind]}[3];
 $ind--;
}
return ($sum / $nbre);
#;

## Indicateur global invisible
Indicators::register_indic(
  'mm-#',
  'code' => \$code,
  'description' => 'Moyenne mobile  %1 jours',
  'explication' => 'C\'est la moyenne des cours des %1 derniers jours.',
  'representation' => 'courbe_1_standard',
  'range' => [ '-%1 + 1', 0 ],
  'color' => 'red',
  'param' => [ '%1' ],
  'visible' => 0         
                          ); 

## Indicateurs exemples visibles
Indicators::register_indic(
  'mm-10',
  'code' => \$code,
  'description' => 'Moyenne mobile  10 jours',
  'explication' => "C'est la moyenne des cours des 10 derniers jours.",
  'representation' => 'courbe_1_standard',
  'range' => [-9, 0],
  'color' => 'blue',
  'param' => [ 10 ],
  'visible' => 1
                          );
Indicators::register_indic(
  'mm-30',
  'code' => \$code,
  'description' => 'Moyenne mobile  30 jours',
  'explication' => "C'est la moyenne des cours des 30 derniers jours.",
  'representation' => 'courbe_1_standard',
  'range' => [-29, 0],
  'color' => 'green',
  'param' => [ 30 ],
  'visible' => 1 
                          );
Indicators::register_indic(
  'mm-100',
  'code' => \$code,
  'description' => 'Moyenne mobile  100 jours',
  'explication' => "C'est la moyenne des cours des 100 derniers jours.",
  'representation' => 'courbe_1_standard',
  'range' => [-99, 0],
  'color' => 'white',
  'param' => [ 100 ],
  'visible' => 1
                          );

1;
