package Language;

#
# Useful for internationalization
# Export the gettext function
#

use POSIX;
use Locale::gettext;
use Conf;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(gettext);

use strict;

setlocale(LC_MESSAGES, "");
bindtextdomain("geniustrader", $Conf{'nls_dir'});
textdomain("geniustrader");

1;

__END__

=head1 Language.pm

This module export the gettext function which enables internationalization
using the Locale::gettext module.

=cut
